=== debian/changelog ===
ros-crystal-rcl (0.6.6-1bionic) bionic; urgency=high

  * Fix leak in __wait_set_clean_up. (#418 <https://github.com/ros2/rcl/issues/418>) (#486 <https://github.com/ros2/rcl/issues/486>)
  * Contributors: Dirk Thomas, Steven! Ragnarök

 -- William Woodall <william@osrfoundation.org>  Sat, 17 Aug 2019 07:00:00 -0000

ros-crystal-rcl (0.6.5-1bionic) bionic; urgency=high

  * Changed error to warning when loggers are created for nodes non-unique names.(#385 <https://github.com/ros2/rcl/issues/385>)
    * Backported by #384 <https://github.com/ros2/rcl/issues/384> for Crystal.
  * Removed test circumvention now that a bug is fixed in rmw_opensplice. (#386 <https://github.com/ros2/rcl/issues/386>)
    * Backported by #368 <https://github.com/ros2/rcl/issues/368> for Crystal.
  * Publish logs to Rosout (#350 <https://github.com/ros2/rcl/issues/350>)
  * Contributors: Nick Burek, Steven! Ragnarök

 -- William Woodall <william@osrfoundation.org>  Fri, 08 Feb 2019 08:00:00 -0000

ros-crystal-rcl (0.6.4-1bionic) bionic; urgency=high

  * Added method for accessing rmw_context from rcl_context (#372 <https://github.com/ros2/rcl/issues/372>)
  * Added guard against bad allocation when calling rcl_arguments_copy() (#367 <https://github.com/ros2/rcl/issues/367>)
  * Updated to ensure that context instance id storage is aligned correctly (#365 <https://github.com/ros2/rcl/issues/365>)
  * Fixed error from uncrustify v0.68 (#364 <https://github.com/ros2/rcl/issues/364>)
  * Contributors: Jacob Perron, William Woodall, sgvandijk

 -- William Woodall <william@osrfoundation.org>  Fri, 11 Jan 2019 08:00:00 -0000

ros-crystal-rcl (0.6.3-1bionic) bionic; urgency=high

  * Set rmw_wait timeout using ros timers too (#357 <https://github.com/ros2/rcl/issues/357>)
  * Contributors: Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-rcl (0.6.2-1bionic) bionic; urgency=high

  * Updated docs about possibility of rcl_take not taking (#356 <https://github.com/ros2/rcl/issues/356>)
  * Bugfix: ensure NULL timeout is passed to rmw_wait() when min_timeout is not set
    Otherwise, there is a risk of integer overflow (e.g. in rmw_fastrtps) and rmw_wait() will wake immediately.
  * Contributors: Jacob Perron, William Woodall

 -- William Woodall <william@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-crystal-rcl (0.6.1-1bionic) bionic; urgency=high

  * Added new cli parameters for configuring the logging. (#327 <https://github.com/ros2/rcl/issues/327>)
  * Added node graph api to rcl. (#333 <https://github.com/ros2/rcl/issues/333>)
  * Fixed compiler warning in clang (#345 <https://github.com/ros2/rcl/issues/345>)
  * Refactored init to not be global (#336 <https://github.com/ros2/rcl/issues/336>)
  * Methods to retrieve matched counts on pub/sub. (#326 <https://github.com/ros2/rcl/issues/326>)
  * Updated to output index in container when adding an entity to a wait set. (#335 <https://github.com/ros2/rcl/issues/335>)
  * Contributors: Jacob Perron, Michael Carroll, Nick Burek, Ross Desmond, William Woodall

 -- William Woodall <william@osrfoundation.org>  Fri, 07 Dec 2018 08:00:00 -0000

ros-crystal-rcl (0.6.0-1bionic) bionic; urgency=high

  * Updated to expand node_secure_root using local_namespace (#300 <https://github.com/ros2/rcl/issues/300>)
  * Moved stdatomic helper to rcutils (#324 <https://github.com/ros2/rcl/issues/324>)
  * Added subfolder argument to the ROSIDL_GET_SRV_TYPE_SUPPORT macro (#322 <https://github.com/ros2/rcl/issues/322>)
  * Updated to use new error handling API from rcutils (#314 <https://github.com/ros2/rcl/issues/314>)
  * Fixed minor documentation issues (#305 <https://github.com/ros2/rcl/issues/305>)
  * Added macro semicolons (#303 <https://github.com/ros2/rcl/issues/303>)
  * Added Rcl timer with ros time (#286 <https://github.com/ros2/rcl/issues/286>)
  * Updated to ensure that timer period is non-negative (#295 <https://github.com/ros2/rcl/issues/295>)
  * Fixed calculation of next timer call (#291 <https://github.com/ros2/rcl/issues/291>)
  * Updated to null deallocated jump callbacks (#294 <https://github.com/ros2/rcl/issues/294>)
  * Included namespaces in get_node_names. (#287 <https://github.com/ros2/rcl/issues/287>)
  * Fixed documentation issues (#288 <https://github.com/ros2/rcl/issues/288>)
  * Updated to check if pointers are null before calling memset (#290 <https://github.com/ros2/rcl/issues/290>)
  * Added multiple time jump callbacks to clock (#284 <https://github.com/ros2/rcl/issues/284>)
  * Consolidated wait set functions (#285 <https://github.com/ros2/rcl/issues/285>)
    * Consolidate functions to clear wait set
    Added rcl_wait_set_clear()
    Added rcl_wait_set_resize()
    Removed
    rcl_wait_set_clear_subscriptions()
    rcl_wait_set_clear_guard_conditions()
    rcl_wait_set_clear_clients()
    rcl_wait_set_clear_services()
    rcl_wait_set_clear_timers()
    rcl_wait_set_resize_subscriptions()
    rcl_wait_set_resize_guard_conditions()
    rcl_wait_set_resize_timers()
    rcl_wait_set_resize_clients()
    rcl_wait_set_resize_services()
  * ROS clock storage initially set to zero (#283 <https://github.com/ros2/rcl/issues/283>)
  * Fixed issue with deallocation of parameter_files (#279 <https://github.com/ros2/rcl/issues/279>)
  * Update to initialize memory before sending a message (#277 <https://github.com/ros2/rcl/issues/277>)
  * Set error message when clock type is not ROS_TIME (#275 <https://github.com/ros2/rcl/issues/275>)
  * Copy allocator passed in to clock init (#274 <https://github.com/ros2/rcl/issues/274>)
  * Update to initialize timer with clock (#272 <https://github.com/ros2/rcl/issues/272>)
  * Updated to use test_msgs instead of std_msgs in tests (#270 <https://github.com/ros2/rcl/issues/270>)
  * Added regression test for node:__ns remapping (#263 <https://github.com/ros2/rcl/issues/263>)
  * Updated to support Uncrustify 0.67 (#266 <https://github.com/ros2/rcl/issues/266>)

