=== debian/control ===
Source: ros-crystal-rcl
Section: misc
Priority: extra
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-crystal-ament-cmake-gtest, ros-crystal-ament-cmake-pytest, ros-crystal-ament-cmake-ros, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-launch, ros-crystal-osrf-testing-tools-cpp, ros-crystal-rcl-interfaces, ros-crystal-rcl-logging-noop, ros-crystal-rcutils, ros-crystal-rmw, ros-crystal-rmw-implementation, ros-crystal-rmw-implementation-cmake, ros-crystal-rosidl-generator-c, ros-crystal-test-msgs, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-ament-cmake, ros-crystal-rcl-interfaces, ros-crystal-rcl-logging-noop, ros-crystal-rcutils, ros-crystal-rmw, ros-crystal-rmw-implementation, ros-crystal-rosidl-default-runtime, ros-crystal-rosidl-generator-c, ros-crystal-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.
